/**********************************************************************
 * Title            tjpbase.h    	                              *
 * Programmer       Keith L. Doty                                     *
 * Date             September 16, 1998                                *
 * Version          1.1 with servo drivers                            *
 *                                                                    *
 * Description							      *
 *   Collects include files and general constants into one file.      *
 **********************************************************************/

/*************************** Includes ********************************/

#include <analog.h>
#include <clocktjp.h>
#include <motortjp.h>
#include <servotjp.h>
#include <serialtp.h>
#include <isrdecl.h>
#include <vectors.h>

/************************ End of Includes ****************************/

/**************************** Constants *********************************/
#define LEFT_MOTOR	0
#define RIGHT_MOTOR	1
#define MAX_SPEED      100
#define ZERO_SPEED       0

#define BUMPER     analog(0)
#define RIGHT_IR   analog(2)
#define LEFT_IR    analog(3)

#define START 	while(BUMPER<120)
#define FRONT_BUMP  (BUMPER>10)&&(BUMPER< 120)
#define BACK_BUMP  BUMPER>120

/* Enable OC4 interrupt and all servo operations */
#define SERVOS_ON     SET_BIT(TMSK1,0x10)             

/*Disable OC4 interrupt: Stops all servo holding torques, useful for energy savings*/
#define SERVOS_OFF    CLEAR_BIT(TMSK1, 0x10)

#define IRE_ON  *(unsigned char *)(0x7000) = 0x07
#define IRE_OFF	*(unsigned char *)(0x7000) = 0x00

/************************ End of Constants ****************************/
