/************************************************************************
 * 			MEKATRONIX Copyright 1998 		      *
 * Title        analog.c                                              *
 * Programmer   Keith L. Doty                                           *
 * Date         February 9, 1998                                        *
 * Version      1                                                       *
 *                                                                      *
 * Description								*
 *   Routines to power up the analog port and to read the 8 channels.   *
 *									*
 ************************************************************************/

/**************************** Includes **********************************/
#include <hc11.h>
#include <mil.h>
/************************************************************************/


/*************************** Prototypes *********************************/

void init_analog(void);   /* Power up A/D */
int analog(int);   	  /* Read analog channel 0<= int <= 7 */

/************************************************************************/



void init_analog(void)
/* This routine must be executed before the function analog is called.  */
/* Power up A/D */
{
  SET_BIT(OPTION,0x80);                  
}

/**********************End of init_analog ******************************/


int analog(int port)
/************************************************************************
 * Function: Takes one reading from the analog port and returns the	*
 *	     value read. 						*
 * Returns:  Analog value read from A/D PORTE                           *
 *                                                                      *
 * Inputs                                                               *
 *   Parameters: None                                                   *
 *   Globals:    None                                                   *
 *   Registers:  PORTE                                                  *
 * Outputs                                                              *
 *   Parameters: None                                                   *
 *   Globals:    None							*
 *   Registers:	 None				                        *
 * Functions called: None                                               *
 ************************************************************************/
{
  ADCTL=port;		/* Address the selected channel */
  while((ADCTL & 0x80) != 0x80); /* Wait for A/D to finish */
  return(ADR1);		/* Return analog value */
}

/**********************End of analog ******************************/
