	.module srvtstjp.c
	.dbfile srvtstjp.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; /************************************************************************
;  * Title        srvtstjp.c                                                 *
;  * Programmer	Keith L. Doty	        				*
;  * Date         May 08, 1999                                            *
;  * Version	1			                		*
;  *								        *
;  * Description								*
;  *   Input two integers to specify the speed and direction of the left  *
;  *   and right wheels. The integers must lie between -100 and +100. Any *
;  *   non-digit character will terminate the integer, e.g., a blank.     *
;  *									*
;  *   	      CAREFUL!!! The robot will start moving immediately!	*
;  *									*
;  * Use Hyperterm with the following settings:                           *
;  *   									*
;  *      COM1, 9600 Baud, 8 bits, No Parity, 1 Stop bit, No Flow         *
;  *      of Control, VT100 Terminal, WrapLines.				*
;  *									*
;  *									*
;  *   To input another pair of speeds, press reset to start the program  *
;  *   over. 								*
;  *									*
;  *  Usage: This program allows you to move the robot at any fixed       *
;  *         wheel speed ratios to generate either straight or circular	*
;  *         motion.  							*
;  ************************************************************************/
;  
; /**************************** Includes **********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of includes *******************************/
; 
; 
; void main(void)
; /****************************** Main ***********************************/
; {
;   int i,lspeed, rspeed, servo_index;
;   unsigned int PW;
;   
; /* VT100 clear screen */ 
;   char c1, clear[]= "\x1b\x5B\x32\x4A\x04"; 
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 
; /* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
;   char place[]= "\x1b[1;1H";	/*Home*/	
; 
;   init_servotjp();
;   init_motortjp();
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
;   init_serial();
;   init_clocktjp();
;   
; while(1)
; {
; 
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
;   printf("%s", clear);  
;   printf("%s", place);
;   
;   printf("\tTitle\t\tsrvtstjp.c\n"
;   "\tProgrammer\tKeith L. Doty\n"
;   "\tDate\t\tMay 07, 1999\n"
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
;   "\tVersion\t\t1\n\n");
; 
;   
;   printf("\nEnter Servo Index: 0 to 2 (PA4-PA6)  ");
;   servo_index = read_int();
; 
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
;   printf("Enter Servo Pulse Width: 1000<PW<4000 or PW=0:   ");
;   PW = read_int();
; 
;   servo(servo_index, PW);
;   
;   
;   printf("Enter percent of left motor speed, a number between -100 and 100:   ");
;   lspeed = read_int();
; 
;   printf("Enter percent of right motor speed, a number between -100 and 100:  ");
;   rspeed = read_int();
; 
;   motorp(RIGHT_MOTOR, rspeed); 
;   motorp(LEFT_MOTOR, lspeed);
;   
;   printf("Type any character to input new data.");
;   c1 = get_char();
; }
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 
;   
; }
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
; /**************************** End of Main ******************************/
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
L20:
	.byte 27,91,50,'J,4,0
L21:
	.byte 27,91,49,59,49,'H,0
;  IX -> 0,x
;              i -> 2,x
;             c1 -> 4,x
;          place -> 5,x
;          clear -> 12,x
;             PW -> 18,x
;    servo_index -> 20,x
;         rspeed -> 22,x
;         lspeed -> 24,x
_main::
	jsr __enterb
	.byte 0x1a
	.dbfile srvtstjp.c
	.dbfunc main
	.dbline 41
	ldd 0,x
	addd #12
	ldy #L20
	pshx
	xgdx
	ldd #6
	jsr __asgnblk
	pulx
	.dbline 44
	ldd 0,x
	addd #5
	ldy #L21
	pshx
	xgdx
	ldd #7
	jsr __asgnblk
	pulx
	.dbline 46
	jsr _init_servotjp
	.dbline 47
	jsr _init_motortjp
	.dbline 48
	jsr _init_serial
	.dbline 49
	jsr _init_clocktjp
	jmp L23
L22:
	.dbline 54
	ldd 0,x
	addd #12
	pshb
	psha
	ldd #L25
	jsr _printf
	puly
	.dbline 55
	ldd 0,x
	addd #5
	pshb
	psha
	ldd #L25
	jsr _printf
	puly
	.dbline 57
	ldd #L26
	jsr _printf
	.dbline 63
	ldd #L27
	jsr _printf
	.dbline 64
	jsr _read_int
	std 20,x
	.dbline 66
	ldd #L28
	jsr _printf
	.dbline 67
	jsr _read_int
	std 18,x
	.dbline 69
	ldd 18,x
	pshb
	psha
	ldd 20,x
	jsr _servo
	puly
	.dbline 72
	ldd #L29
	jsr _printf
	.dbline 73
	jsr _read_int
	std 24,x
	.dbline 75
	ldd #L30
	jsr _printf
	.dbline 76
	jsr _read_int
	std 22,x
	.dbline 78
	ldd 22,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 79
	ldd 24,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 81
	ldd #L31
	jsr _printf
	.dbline 82
	jsr _get_char
	stab 4,x
	.dbline 83
L23:
	.dbline 51
	jmp L22
L19:
	xgdx
	addd #26
	xgdx
	txs
	pulx
	rts
	.area bss
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L31:
	.byte 'T,'y,'p,'e,32,'a,'n,'y,32,'c,'h,'a,'r,'a,'c,'t
	.byte 'e,'r,32,'t,'o,32,'i,'n,'p,'u,'t,32,'n,'e,'w,32
	.byte 'd,'a,'t,'a,46,0
L30:
	.byte 'E,'n,'t,'e,'r,32,'p,'e,'r,'c,'e,'n,'t,32,'o,'f
	.byte 32,'r,'i,'g,'h,'t,32,'m,'o,'t,'o,'r,32,'s,'p,'e
	.byte 'e,'d,44,32,'a,32,'n,'u,'m,'b,'e,'r,32,'b,'e,'t
	.byte 'w,'e,'e,'n,32,45,49,48,48,32,'a,'n,'d,32,49,48
	.byte 48,58,32,32,0
L29:
	.byte 'E,'n,'t,'e,'r,32,'p,'e,'r,'c,'e,'n,'t,32,'o,'f
	.byte 32,'l,'e,'f,'t,32,'m,'o,'t,'o,'r,32,'s,'p,'e,'e
	.byte 'd,44,32,'a,32,'n,'u,'m,'b,'e,'r,32,'b,'e,'t,'w
	.byte 'e,'e,'n,32,45,49,48,48,32,'a,'n,'d,32,49,48,48
	.byte 58,32,32,32,0
L28:
	.byte 'E,'n,'t,'e,'r,32,'S,'e,'r,'v,'o,32,'P,'u,'l,'s
	.byte 'e,32,'W,'i,'d,'t,'h,58,32,49,48,48,48,60,'P,'W
	.byte 60,52,48,48,48,32,'o,'r,32,'P,'W,61,48,58,32,32
	.byte 32,0
L27:
	.byte 10,'E,'n,'t,'e,'r,32,'S,'e,'r,'v,'o,32,'I,'n,'d
	.byte 'e,'x,58,32,48,32,'t,'o,32,50,32,40,'P,'A,52,45
	.byte 'P,'A,54,41,32,32,0
L26:
	.byte 9,'T,'i,'t,'l,'e,9,9,'s,'r,'v,'t,'s,'t,'j,'p
	.byte 46,'c,10,9,'P,'r,'o,'g,'r,'a,'m,'m,'e,'r,9,'K
	.byte 'e,'i,'t,'h,32,'L,46,32,'D,'o,'t,'y,10,9,'D,'a
	.byte 't,'e,9,9,'M,'a,'y,32,48,55,44,32,49,57,57,57
	.byte 10,9,'V,'e,'r,'s,'i,'o,'n,9,9,49,10,10,0
L25:
	.byte 37,'s,0
