	.module tjpargos.c
	.dbfile tjpargos.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; /**********************************************************************
; *                        MEKATRONIX Copyright 1998
; *
; * Title        tjpargos.c
; * Programmers  Keith L. Doty
; * Date         Sept. 09, 1998
; * Version      1
; 
; * Description 
; This program outputs the values of the IR detectors and the bumper switches
; continuously. This program lets you test the basic sensor suite of the
; TJ Pro robot.
; 
; A physical, serial communication link must be present, e.g. the standard
; Mekatronix serial cable connection via the MB2325 board.
; 
; Serial Protocol of this program:
;   baud=9600, 8 data bits, 1 stop bit, no parity, no flow control.
;  
;  Example: 
;    Configure Hyperterm on Win95:
;    Direct to COM1, 9600 baud, 8 bits, no parity, 1 stop bit,
;    no flow control.
; 
; **********************************************************************/
; 
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of Includes ****************************/
; 
; void sensors_tst(void);
; void motor_tst(void);
; void servo_tst(void);
; 
; /***************************** Main **********************************/
; void main(void)
; {
;   unsigned int bl, cv, fb, rb, run_test;
;   char clear[]= "\x1b\x5B\x32\x4A\x04";  /* clear screen */ 
;   char place[]= "\x1b[1;1H";		/* Home cursor */
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
; 
;   init_analog();
;   init_clocktjp();
;   init_serial();
;   init_motortjp();
;   init_servotjp();
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 
; 
;   printf("%s", clear);  /*clear screen*/
;   printf("%s", place);  /*home cursor*/
; 
;   printf("\tTitle\t\ttjprotst.c\n"
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
;   "\tProgrammer\tKeith L. Doty\n"
;   "\tDate\t\tMarch 22, 1999\n"
;   "\tVersion\t\t1\n\n");
; 
;   printf("Select one of the following TJ PRO test procedures\n"
;          "   1. Test TJ PRO Sensors \n"
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
;          "   2. Test TJ PRO Servos\n"
; 	     "   3. Test TJ PRO Motors(CAREFUL!!! The robot will start moving immediately!)\n\n");
; 
;   run_test= read_int();
; 
;     switch (run_test)/*Select a test procedure */
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
;        {
;          case 1: sensors_tst(); break;
;          case 2: servo_tst(); break;
; 	     case 3: motor_tst(); break;
;        }
;   
; }
; 
; /***************************** Sensor **********************************/
; void sensors_tst(void)
; {
; 
; /* VT100 clear screen */ 
;   char clear[]= "\x1b\x5B\x32\x4A\x04"; 
; 
; /* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
;   char place[]= "\x1b[1;1H";	/*Home*/	
; 
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
;   IRE_ON; /*turn on IR emitters */
; 
;   printf("%s", clear);  
;   printf("%s", place);
;   
;   printf("\tTitle\t\tsensetjp.c\n"
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
;   "\tProgrammer\tKeith L. Doty\n"
;   "\tDate\t\tSeptember, 1998\n"
;   "\tVersion\t\t1\n\n");
; 
;   printf("TALRIK JUNIOR PROFESSIONAL SENSOR READINGS\n\n");
;   printf("Left IR    Right IR    Bumper\n"); 
; 
;   while(1)
;   {
; 
;   /*
;     Move cursor to data field position and print data
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
;     The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
;   */
;     printf("\x1b[10;1H    \b\b\b\b\b%d",LEFT_IR);
;     printf("\x1b[10;13H   \b\b\b\b%d",RIGHT_IR);
;     printf("\x1b[10;25H   \b\b\b\b%d",BUMPER);
;     wait(50);
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 
;   }/*end while(1)*/
; }
; /***************************** End of Sensor **********************************/
; 
; 
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; void motor_tst(void)
; /**************************** motor_tst *********************************
;  * Description								*
;  *   Input two integers to specify the speed and direction of the left  *
;  *   and right wheels. The integers must lie between -100 and +100. Any *
;  *   non-digit character will terminate the integer, e.g., a blank.     *
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
;  *									*
;  *   	      CAREFUL!!! The robot will start moving immediately!	*
;  *									*
;  *   To input another pair of speeds, press reset to start the program  *
;  *   over. 								*
;  *									*
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
;  *  Usage: This function allows you to move the robot at any fixed      *
;  *         wheel speed ratios to generate either straight or circular	*
;  *         motion.  							*
;  ************************************************************************/
; {
;   int i;
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; /* VT100 clear screen */ 
;   char clear[]= "\x1b\x5B\x32\x4A\x04"; 
; 
; /* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
;   char place[]= "\x1b[1;1H";	/*Home*/	
; 
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
;   printf("%s", clear);  
;   printf("%s", place);
;  
;   printf("Motor Speed = \n\n");
;   printf("Press TJ PRO Reset Switch to select another test.");
; 
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
;   while(1)
;   {
;     for( i=-100; i< 101; i +=10)
;     {
;       motorp(RIGHT_MOTOR, i); 
;       motorp(LEFT_MOTOR, i);
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
;       printf("\x1b[1;14H      ");
;       printf("\x1b[1;14H%d", i);
;       wait(1000);
;     }
; 
;     for( i=100; i> -101; i -=10)
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
L20:
	.byte 27,91,50,'J,4,0
L21:
	.byte 27,91,49,59,49,'H,0
;  IX -> 0,x
;             rb -> 3,x
;             fb -> 5,x
;             cv -> 7,x
;             bl -> 9,x
;          place -> 11,x
;          clear -> 18,x
;       run_test -> 24,x
_main::
	jsr __enterb
	.byte 0x1a
	.dbfile tjpargos.c
	.dbfunc main
	.dbline 40
	ldd 0,x
	addd #18
	ldy #L20
	pshx
	xgdx
	ldd #6
	jsr __asgnblk
	pulx
	.dbline 41
	ldd 0,x
	addd #11
	ldy #L21
	pshx
	xgdx
	ldd #7
	jsr __asgnblk
	pulx
	.dbline 43
	jsr _init_analog
	.dbline 44
	jsr _init_clocktjp
	.dbline 45
	jsr _init_serial
	.dbline 46
	jsr _init_motortjp
	.dbline 47
	jsr _init_servotjp
	.dbline 50
	ldd 0,x
	addd #18
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 51
	ldd 0,x
	addd #11
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 53
	ldd #L23
	jsr _printf
	.dbline 58
	ldd #L24
	jsr _printf
	.dbline 63
	jsr _read_int
	std 24,x
	.dbline 65
	ldd 24,x
	cpd #1
	beq L27
	ldd 24,x
	cpd #2
	beq L28
	ldd 24,x
	cpd #3
	beq L29
	bra L25
L27:
	.dbline 67
	jsr _sensors_tst
	bra L26
L28:
	.dbline 68
	jsr _servo_tst
	bra L26
L29:
	.dbline 69
	jsr _motor_tst
L25:
L26:
	.dbline 72
L19:
	xgdx
	addd #26
	xgdx
	txs
	pulx
	rts
L31:
	.byte 27,91,50,'J,4,0
L32:
	.byte 27,91,49,59,49,'H,0
;  IX -> 0,x
;          place -> 3,x
;          clear -> 10,x
_sensors_tst::
	jsr __enterb
	.byte 0x10
	.dbfunc sensors_tst
	.dbline 79
	ldd 0,x
	addd #10
	ldy #L31
	pshx
	xgdx
	ldd #6
	jsr __asgnblk
	pulx
	.dbline 82
	ldd 0,x
	addd #3
	ldy #L32
	pshx
	xgdx
	ldd #7
	jsr __asgnblk
	pulx
	.dbline 84
	ldab #7
	stab 0x7000
	.dbline 86
	ldd 0,x
	addd #10
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 87
	ldd 0,x
	addd #3
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 89
	ldd #L33
	jsr _printf
	.dbline 94
	ldd #L34
	jsr _printf
	.dbline 95
	ldd #L35
	jsr _printf
	bra L37
L36:
	.dbline 104
	ldd #3
	jsr _analog
	pshb
	psha
	ldd #L39
	jsr _printf
	puly
	.dbline 105
	ldd #2
	jsr _analog
	pshb
	psha
	ldd #L40
	jsr _printf
	puly
	.dbline 106
	ldd #0
	jsr _analog
	pshb
	psha
	ldd #L41
	jsr _printf
	puly
	.dbline 107
	ldd #50
	jsr _wait
	.dbline 109
L37:
	.dbline 97
	bra L36
L30:
	xgdx
	addd #16
	xgdx
	txs
	pulx
	rts
L43:
	.byte 27,91,50,'J,4,0
L44:
	.byte 27,91,49,59,49,'H,0
;  IX -> 0,x
;          place -> 3,x
;          clear -> 10,x
;              i -> 16,x
_motor_tst::
	jsr __enterb
	.byte 0x12
	.dbfunc motor_tst
	.dbline 133
	ldd 0,x
	addd #10
	ldy #L43
	pshx
	xgdx
	ldd #6
	jsr __asgnblk
	pulx
	.dbline 136
	ldd 0,x
	addd #3
	ldy #L44
	pshx
	xgdx
	ldd #7
	jsr __asgnblk
	pulx
	.dbline 138
	ldd 0,x
	addd #10
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 139
	ldd 0,x
	addd #3
	pshb
	psha
	ldd #L22
	jsr _printf
	puly
	.dbline 141
	ldd #L45
	jsr _printf
	.dbline 142
	ldd #L46
	jsr _printf
	jmp L48
L47:
	.dbline 146
	ldd #-100
	std 16,x
L50:
	.dbline 148
	ldd 16,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 149
	ldd 16,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 150
	ldd #L54
	jsr _printf
	.dbline 151
	ldd 16,x
	pshb
	psha
	ldd #L55
	jsr _printf
	puly
	.dbline 152
	ldd #1000
	jsr _wait
	.dbline 153
L51:
	ldd 16,x
	addd #10
	std 16,x
	cpd #101
	blt L50
	.dbline 155
	ldd #100
	std 16,x
L56:
	.dbline 157
;     {
;       motorp(RIGHT_MOTOR, i); 
	ldd 16,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 158
;       motorp(LEFT_MOTOR, i);
	ldd 16,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 159
;       printf("\x1b[1;14H      ");
	ldd #L54
	jsr _printf
	.dbline 160
;       printf("\x1b[1;14H%d", i);
	ldd 16,x
	pshb
	psha
	ldd #L55
	jsr _printf
	puly
	.dbline 161
;       wait(1000);
	ldd #1000
	jsr _wait
	.dbline 162
;     }
L57:
	ldd 16,x
	subd #10
	std 16,x
	cpd #-101
	bgt L56
	.dbline 163
L48:
	.dbline 144
	jmp L47
L42:
	xgdx
	addd #18
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;              i -> 2,x
_servo_tst::
	jsr __enterb
	.byte 0x4
	.dbfunc servo_tst
	.dbline 173
;   }
; 
; }
; /**************************** motor_tst ******************************/
; 
; 
; void servo_tst(void)
; {
;   int i;
;   
;   printf("Press TJ PRO Reset Switch to select another test.");
	ldd #L46
	jsr _printf
	jmp L62
L61:
	.dbline 177
; 
;   while(1)
;     {  
;       for(i=1000; i<4501; i+=20) /*Go in one direction*/
	ldd #1000
	std 2,x
L64:
	.dbline 179
;         {
;           servo(0, i);  /*SERVOZ, PA4*/
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 180
;           servo(1, i);  /*SERVO1, PA5*/
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 181
;           servo(2,i);   /*SERVO2, PA6*/
	ldd 2,x
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 182
;           wait(40);     /*Wait 40 milliseconds between commands*/
	ldd #40
	jsr _wait
	.dbline 183
;         }
L65:
	ldd 2,x
	addd #20
	std 2,x
	cpd #4501
	blt L64
	.dbline 184
;       for(i=4500; i>999; i-=20) /*Reverse direction*/
	ldd #4500
	std 2,x
L68:
	.dbline 186
;         {
;           servo(0, i);
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 187
;           servo(1, i);
	ldd 2,x
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 188
;           servo(2,i);
	ldd 2,x
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 189
;           wait(40);
	ldd #40
	jsr _wait
	.dbline 190
;         }
L69:
	ldd 2,x
	subd #20
	std 2,x
	cpd #999
	bgt L68
	.dbline 191
L62:
	.dbline 175
	jmp L61
L60:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
	.area bss
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L55:
	.byte 27,91,49,59,49,52,'H,37,'d,0
L54:
	.byte 27,91,49,59,49,52,'H,32,32,32,32,32,32,0
L46:
	.byte 'P,'r,'e,'s,'s,32,'T,'J,32,'P,'R,'O,32,'R,'e,'s
	.byte 'e,'t,32,'S,'w,'i,'t,'c,'h,32,'t,'o,32,'s,'e,'l
	.byte 'e,'c,'t,32,'a,'n,'o,'t,'h,'e,'r,32,'t,'e,'s,'t
	.byte 46,0
L45:
	.byte 'M,'o,'t,'o,'r,32,'S,'p,'e,'e,'d,32,61,32,10,10
	.byte 0
L41:
	.byte 27,91,49,48,59,50,53,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L40:
	.byte 27,91,49,48,59,49,51,'H,32,32,32,8,8,8,8,37
	.byte 'd,0
L39:
	.byte 27,91,49,48,59,49,'H,32,32,32,32,8,8,8,8,8
	.byte 37,'d,0
L35:
	.byte 'L,'e,'f,'t,32,'I,'R,32,32,32,32,'R,'i,'g,'h,'t
	.byte 32,'I,'R,32,32,32,32,'B,'u,'m,'p,'e,'r,10,0
L34:
	.byte 'T,'A,'L,'R,'I,'K,32,'J,'U,'N,'I,'O,'R,32,'P,'R
	.byte 'O,'F,'E,'S,'S,'I,'O,'N,'A,'L,32,'S,'E,'N,'S,'O
	.byte 'R,32,'R,'E,'A,'D,'I,'N,'G,'S,10,10,0
L33:
	.byte 9,'T,'i,'t,'l,'e,9,9,'s,'e,'n,'s,'e,'t,'j,'p
	.byte 46,'c,10,9,'P,'r,'o,'g,'r,'a,'m,'m,'e,'r,9,'K
	.byte 'e,'i,'t,'h,32,'L,46,32,'D,'o,'t,'y,10,9,'D,'a
	.byte 't,'e,9,9,'S,'e,'p,'t,'e,'m,'b,'e,'r,44,32,49
	.byte 57,57,56,10,9,'V,'e,'r,'s,'i,'o,'n,9,9,49,10
	.byte 10,0
L24:
	.byte 'S,'e,'l,'e,'c,'t,32,'o,'n,'e,32,'o,'f,32,'t,'h
	.byte 'e,32,'f,'o,'l,'l,'o,'w,'i,'n,'g,32,'T,'J,32,'P
	.byte 'R,'O,32,'t,'e,'s,'t,32,'p,'r,'o,'c,'e,'d,'u,'r
	.byte 'e,'s,10,32,32,32,49,46,32,'T,'e,'s,'t,32,'T,'J
	.byte 32,'P,'R,'O,32,'S,'e,'n,'s,'o,'r,'s,32,10,32,32
	.byte 32,50,46,32,'T,'e,'s,'t,32,'T,'J,32,'P,'R,'O,32
	.byte 'S,'e,'r,'v,'o,'s,10,32,32,32,51,46,32,'T,'e,'s
	.byte 't,32,'T,'J,32,'P,'R,'O,32,'M,'o,'t,'o,'r,'s,40
	.byte 'C,'A,'R,'E,'F,'U,'L,33,33,33,32,'T,'h,'e,32,'r
	.byte 'o,'b,'o,'t,32,'w,'i,'l,'l,32,'s,'t,'a,'r,'t,32
	.byte 'm,'o,'v,'i,'n,'g,32,'i,'m,'m,'e,'d,'i,'a,'t,'e
	.byte 'l,'y,33,41,10,10,0
L23:
	.byte 9,'T,'i,'t,'l,'e,9,9,'t,'j,'p,'r,'o,'t,'s,'t
	.byte 46,'c,10,9,'P,'r,'o,'g,'r,'a,'m,'m,'e,'r,9,'K
	.byte 'e,'i,'t,'h,32,'L,46,32,'D,'o,'t,'y,10,9,'D,'a
	.byte 't,'e,9,9,'M,'a,'r,'c,'h,32,50,50,44,32,49,57
	.byte 57,57,10,9,'V,'e,'r,'s,'i,'o,'n,9,9,49,10,10
	.byte 0
L22:
	.byte 37,'s,0
