/**********************************************************************
*                        MEKATRONIX Copyright 1998
*
* Title        sensetjp.c
* Programmers  Keith L. Doty
* Date         Sept. 09, 1998
* Version      1

* Description 
This program outputs the values of the IR detectors and the bumper switches
continuously. This program lets you test the basic sensor suite of the
TJ Pro robot.

A physical, serial communication link must be present, e.g. the standard
Mekatronix serial cable connection via the MB2325 board.

Serial Protocol of this program:
  baud=9600, 8 data bits, 1 stop bit, no parity, no flow control.
 
 Example: 
   Configure Hyperterm on Win95:
   Direct to COM1, 9600 baud, 8 bits, no parity, 1 stop bit,
   no flow control.

**********************************************************************/

/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/


/***************************** Main **********************************/
void main(void)
{

/* VT100 clear screen */ 
  char clear[]= "\x1b\x5B\x32\x4A\x04"; 

/* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
  char place[]= "\x1b[1;1H";	/*Home*/	

  init_analog();
  init_clocktjp();
  init_serial();

  IRE_ON; /*turn on IR emitters */

  printf("%s", clear);  
  printf("%s", place);
  
  printf("\tTitle\t\tsensetjp.c\n"
  "\tProgrammer\tKeith L. Doty\n"
  "\tDate\t\tSeptember, 1998\n"
  "\tVersion\t\t1\n\n");

  printf("TALRIK JUNIOR PROFESSIONAL SENSOR READINGS\n\n");
  printf("Left IR    Right IR    Bumper\n"); 

  while(1)
  {

  /*
    Move cursor to data field position and print data
    The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
  */
    printf("\x1b[10;1H    \b\b\b\b\b%d",LEFT_IR);
    printf("\x1b[10;13H   \b\b\b\b%d",RIGHT_IR);
    printf("\x1b[10;25H   \b\b\b\b%d",BUMPER);
    wait(50);

  }/*end while(1)*/
}
/***************************** End of Main **********************************/
